unit UACBridge;

interface

function IsAdminLevel: Boolean;





implementation

uses
  Windows;

function CheckTokenMembership(TokenHandle: THandle; SidToCheck: PSID; var IsMember: BOOL): BOOL; stdcall; external 'AdvAPI32.dll';

const
  SECURITY_NT_AUTHORITY: TSIDIdentifierAuthority = (Value: (0, 0, 0, 0, 0, 5));
  SECURITY_BUILTIN_DOMAIN_RID = $00000020;
  DOMAIN_ALIAS_RID_ADMINS = $00000220;



function IsAdminLevel: Boolean;
var
  fIsRunAsAdmin: BOOL;
  pAdministratorsGroup: PSID;
  NtAuthority: TSIDIdentifierAuthority;

begin
  Result := False;

  //Allocate and initialize an SID of the administrators group.
  NtAuthority := SECURITY_NT_AUTHORITY;
  pAdministratorsGroup := nil;
  if AllocateAndInitializeSid(NtAuthority, 2, SECURITY_BUILTIN_DOMAIN_RID, DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0, pAdministratorsGroup) then begin
    //Determine whether the SID of administrators group is enabled in the primary access token of the process.
    fIsRunAsAdmin := FALSE;
    if CheckTokenMembership(0, pAdministratorsGroup, fIsRunAsAdmin) then
      Result := fIsRunAsAdmin
    ;
  end;

  if pAdministratorsGroup <> nil then begin
    FreeSid(pAdministratorsGroup);
    pAdministratorsGroup := nil;
  end;
end;

end.
